unit FMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, DialSpinEdit, ExtCtrls, Menus, ComCtrls, CChara,
	StringUnitLight, NCommon, StrUtils, XPMan;

type
	{
	TCheckBox = class(StdCtrls.TCheckBox)
	protected
		function CanAutoSize(var NewWidth: Integer; var NewHeight: Integer): Boolean;override;
	published
		property AutoSize;
	end;
	}

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    F1: TMenuItem;
    PopupMenu1: TPopupMenu;
    A1: TMenuItem;
    D1: TMenuItem;
    M1: TMenuItem;
    PLP1: TMenuItem;
    GMG1: TMenuItem;
    S1: TMenuItem;
    C1: TMenuItem;
    ListView1: TListView;
    Panel6: TPanel;
    Panel5: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Memo1: TMemo;
    Button1: TButton;
		CheckBox1: TCheckBox;
		FateDSE: TDialSpinEdit;
		CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    B1DSE: TDialSpinEdit;
    B2DSE: TDialSpinEdit;
    B3DSE: TDialSpinEdit;
    CheckBox5: TCheckBox;
    B1BDSE: TDialSpinEdit;
    B2BDSE: TDialSpinEdit;
    B3BDSE: TDialSpinEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ListBox1: TListBox;
    Splitter1: TSplitter;
    Button2: TButton;
    ListView2: TListView;
    N1: TMenuItem;
    N2: TMenuItem;
    PopupMenu2: TPopupMenu;
    D2: TMenuItem;
    B1: TMenuItem;
    R1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    C2: TMenuItem;
    GridPanel2: TGridPanel;
    HPLA: TLabel;
    HPDSE: TDialSpinEdit;
    HPLB: TLabel;
    MHPDSE: TDialSpinEdit;
    MPLA: TLabel;
    MPDSE: TDialSpinEdit;
    MPLB: TLabel;
    MMPDSE: TDialSpinEdit;
    FPLA: TLabel;
    FPDSE: TDialSpinEdit;
    FPLB: TLabel;
    MFPDSE: TDialSpinEdit;
    FMPLA: TLabel;
    FMPDSE: TDialSpinEdit;
    FMPLB: TLabel;
    MFMPDSE: TDialSpinEdit;
    Splitter2: TSplitter;
    procedure S1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure PLP1Click(Sender: TObject);
    procedure C1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
		procedure FormCreate(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
			Selected: Boolean);
		procedure ListBox1Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
		procedure CheckBox2Click(Sender: TObject);
    procedure HPDSEChange(Sender: TObject);
		procedure FPDSEChange(Sender: TObject);
		procedure MPDSEChange(Sender: TObject);
		procedure FMPDSEChange(Sender: TObject);
    procedure MHPDSEChange(Sender: TObject);
    procedure MMPDSEChange(Sender: TObject);
    procedure MFPDSEChange(Sender: TObject);
		procedure MFMPDSEChange(Sender: TObject);
    procedure D2Click(Sender: TObject);
		procedure A1Click(Sender: TObject);
    procedure ListView2Change(Sender: TObject; Item: TListItem;
			Change: TItemChange);
		procedure ListView2DblClick(Sender: TObject);
    procedure D1Click(Sender: TObject);
		procedure N3Click(Sender: TObject);
		procedure C2Click(Sender: TObject);
    procedure R1Click(Sender: TObject);
    procedure HPLADblClick(Sender: TObject);
    procedure MPLADblClick(Sender: TObject);
    procedure FPLADblClick(Sender: TObject);
    procedure FMPLADblClick(Sender: TObject);
	private
		{ Private 錾 }
		FData : TTRPGCharactorDataList;
		Index : Integer;
		FRoundCounter : Integer;

		procedure SetRoundNum;

		procedure AddCharactor(Sender : TObject);
		procedure ReloadData(const LI : TListItem);
		procedure ReloadBuff(const LI : TListItem);
		procedure SelectData(const ItemIndex : Integer);
		procedure PrintData;
	public
		{ Public 錾 }
	end;

var
	MainForm: TMainForm;

implementation

uses FSoft, FChara, FBuff;

{$R *.dfm}

{ TCheckBox }
{
function TCheckBox.CanAutoSize(var NewWidth, NewHeight: Integer): Boolean;
var
	Size : TSize;
	hd : HDC;
begin
	NewHeight := Self.Font.Size * 2 + 1;
	hd := GetDC(Self.Handle);
	SelectObject(hd, Self.Font.Handle);
	GetTextExtentPoint32(hd,PChar(Self.Caption),Length(Self.Caption),Size);
	ReleaseDC(Self.Handle,hd);
	NewWidth := Size.cx + 19;
	Result := False;
end;
}

procedure TMainForm.A1Click(Sender: TObject);
var LC : Integer;
begin
	if Index >= 0 then begin
		if ListView2.ItemIndex >= 0 then
			BuffForm.Data := FData[Index].Buffs[ListView2.ItemIndex]
		else BuffForm.Data := NIL;

		BuffForm.DefaultTags := NIL;
		for LC := 0 to FData[Index].Message.Count - 1 do
			BuffForm.DefaultTags.AddStrings(FData[Index].Message[LC].Tags);

		if BuffForm.Execute then begin
			ListView2.OnChange := NIL;
			
			if ListView2.ItemIndex >= 0 then begin
				FData[Index].Buffs[ListView2.ItemIndex].Assign(BuffForm.Data);
				ReloadBuff(ListView2.Selected);
			end else begin
				FData[Index].Buffs.Add.Assign(BuffForm.Data);
				ReloadBuff(ListView2.Items.Add);
			end;
			ListView2.OnChange := ListView2Change;
			PrintData;
		end;
	end;
end;

procedure TMainForm.AddCharactor(Sender: TObject);
begin
	FData.Add.Assign(CharactorForm.Data);
	ReloadData(ListView1.Items.Add);
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
	if Sender is TButton then
		DestEditForm.SendMes(Memo1.Text,TButton(Sender).Caption = 'ڔ')
	else DestEditForm.SendMes(Memo1.Text,False);
end;

procedure TMainForm.C1Click(Sender: TObject);
begin
	CharactorForm.OnAddCharactor := AddCharactor;
	if CharactorForm.Execute(GMG1.Checked) then begin
		if ListView1.ItemIndex < 0 then begin
			AddCharactor(Sender);
			Index := 0;
			ListView1.ItemIndex := 0;
		end else begin
			FData[Index].Assign(CharactorForm.Data);
		end;
		SelectData(Index);
	end;
end;

procedure TMainForm.C2Click(Sender: TObject);
begin
	FRoundCounter := 0;
	SetRoundNum;
end;

procedure TMainForm.CheckBox2Click(Sender: TObject);
begin
	if CheckBox2.Checked then begin
		Button1.Caption := 'ڔ';
		Button2.Caption := '\';
	end else begin
		Button2.Caption := 'ڔ';
		Button1.Caption := '\';
	end;
end;

procedure TMainForm.CheckBox3Click(Sender: TObject);
begin
	PrintData;
end;

procedure TMainForm.D1Click(Sender: TObject);
begin
	if (Index >= 0) and (ListView2.ItemIndex >= 0) then begin
		FData[Index].Buffs.Delete(ListView2.ItemIndex);
		ListView2.OnChange := NIL;
		ListView2.Items.Delete(ListView2.ItemIndex);
		ListView2.OnChange := ListView2Change;
		PrintData;
	end;
end;

procedure TMainForm.D2Click(Sender: TObject);
begin
	if ListView1.ItemIndex >= 0 then begin
		if Index = ListView1.ItemIndex then
			Index := - 1;
		FData.Delete(ListView1.ItemIndex);
		ListView1.Items.Delete(ListView1.ItemIndex);
		ListBox1.Items.Clear;
		ListView2.Items.Clear;
	end;
end;

procedure TMainForm.FMPDSEChange(Sender: TObject);
begin
	if Index >= 0 then begin
		FData[Index].FMP_Now := FMPDSE.Value;
		ReloadData(ListView1.Items[Index]);
	end;
end;       

procedure ChartLabel(const Text:String; const Now,Max:TDialSpinEdit);
var S : String;
begin
	if not Now.Visible then Exit;
	S := Text + ' ' + inttostr(Now.Value);
	if Max.Visible then begin
		S := S + '/' + inttostr(Max.Value);
	end;

	if Trim(MainForm.Memo1.Text) = '' then MainForm.Memo1.Text := S else begin
		MainForm.Memo1.Text := MainForm.Memo1.Text + ' ' + S;
	end;
end;

procedure TMainForm.FMPLADblClick(Sender: TObject);
begin
	ChartLabel(FMPLA.Caption,FMPDSE,MFMPDSE);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
	FData := TTRPGCharactorDataList.Create;
	Index := - 1;
	{
	CheckBox3.AutoSize := True;
	CheckBox4.AutoSize := True;
  }
	//ShowMessage(IntToStr(CheckBox3.Width) + ',' + inttostr(CheckBox3.Height));
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
	FData.Free;
	Index := - 1;
end;

procedure TMainForm.FPDSEChange(Sender: TObject);
begin
	if Index >= 0 then begin
		FData[Index].FP_Now := FPDSE.Value;
		ReloadData(ListView1.Items[Index]);
	end;
end;

procedure TMainForm.FPLADblClick(Sender: TObject);
begin
	ChartLabel(FPLA.Caption,FPDSE,MFPDSE);
end;

procedure TMainForm.HPDSEChange(Sender: TObject);
begin
	if Index >= 0 then begin
		FData[Index].HP_Now := HPDSE.Value;
		ReloadData(ListView1.Items[Index]);
	end;
end;

procedure TMainForm.HPLADblClick(Sender: TObject);
begin
	ChartLabel(HPLA.Caption,HPDSE,MHPDSE);
end;

procedure TMainForm.ListBox1Click(Sender: TObject);
begin
	PrintData;
end;

procedure TMainForm.ListView1SelectItem(Sender: TObject; Item: TListItem;
	Selected: Boolean);
begin
	if Selected then begin
		SelectData(Item.Index);
	end;
end;

procedure TMainForm.ListView2Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
	if (Change = ctState) and (Assigned(Item)) then begin
		if (Index >= 0) then begin
			if FData[Index].Buffs[Item.Index].Checked <> Item.Checked then begin
				FData[Index].Buffs[Item.Index].Checked := Item.Checked;
				PrintData;
			end;
		end;
	end;
end;

procedure TMainForm.ListView2DblClick(Sender: TObject);
begin
	A1.Click;
end;

procedure TMainForm.MFMPDSEChange(Sender: TObject);
var I : Integer;
begin
	if Index >= 0 then begin
		I := MFMPDSE.Value - FData[Index].FMP_Max;
		FData[Index].FMP_Max := MFMPDSE.Value;
		FMPDSE.Value := FMPDSE.Value + I;
		FMPDSEChange(Sender);
	end;
end;

procedure TMainForm.MFPDSEChange(Sender: TObject);
var I : Integer;
begin
	if Index >= 0 then begin
		I := MFPDSE.Value - FData[Index].FP_Max;
		FData[Index].FP_Max := FPDSE.Value;
		FPDSE.Value := FPDSE.Value + I;
		FPDSEChange(Sender);
	end;
end;

procedure TMainForm.MHPDSEChange(Sender: TObject);
var I : Integer;
begin
	if Index >= 0 then begin
		I := MHPDSE.Value - FData[Index].HP_Max;
		FData[Index].HP_Max := MHPDSE.Value;
		HPDSE.Value := HPDSE.Value + I;
		HPDSEChange(Sender);
	end;
end;

procedure TMainForm.MMPDSEChange(Sender: TObject);
var I : Integer;
begin
	if Index >= 0 then begin
		I := MMPDSE.Value - FData[Index].MP_Max;
		FData[Index].MP_Max := MMPDSE.Value;
		MPDSE.Value := MPDSE.Value + I;
		MPDSEChange(Sender);
	end;
end;

procedure TMainForm.MPDSEChange(Sender: TObject);
begin
	if Index >= 0 then begin
		FData[Index].MP_Now := MPDSE.Value;
		ReloadData(ListView1.Items[Index]);
	end;
end;

procedure TMainForm.MPLADblClick(Sender: TObject);
begin
	ChartLabel(MPLA.Caption,MPDSE,MMPDSE);
end;

procedure TMainForm.N2Click(Sender: TObject);
begin
	Close;
end;

procedure TMainForm.N3Click(Sender: TObject);
var
	LC: Integer;
begin
	Inc(FRoundCounter);
	SetRoundNum;
	
	for LC := 0 to FData.Count - 1 do begin
		FData[LC].Buffs.CountDown;
	end;

	ListView2.Items.BeginUpdate;
	ListView2.OnChange := NIL;
	ListView2.Items.Clear;
	if Index >= 0 then begin
		for LC := 0 to FData[Index].Buffs.Count - 1 do
			ReloadBuff(ListView2.Items.Add);
	end;
	ListView2.Items.EndUpdate;
	ListView2.OnChange := ListView2Change;
	PrintData;
end;

procedure TMainForm.PLP1Click(Sender: TObject);
begin
	if Sender = PLP1 then begin
		if PLP1.Checked then Sender := NIL;
		PLP1.Checked := True;
	end else begin
		if not GMG1.Checked then begin
			Self.Width := Self.Width + ListView1.Width + Splitter1.Width;
		end;
		GMG1.Checked := True;
	end;
	Splitter1.Visible := GMG1.Checked;
	ListView1.Visible := GMG1.Checked;

	if Sender = PLP1 then begin
		Self.Width := Self.Width - ListView1.Width - Splitter1.Width;
	end;
end;

function PlusNum(const Dices,Vals:Integer;const DiceText : String = 'd'):String;
	function RtoStr(const I : Integer):String;
	begin
		if I = 0 then Result := ''
		else if I > 0 then Result := '+' + IntToStr(I)
		else Result := InttoStr(I);
	end;
begin
	if Dices = 0 then begin
		Result := RtoStr(Vals);
	end else begin
		Result := RtoStr(Dices) + DiceText + RtoStr(Vals);
	end;
end;

procedure TMainForm.PrintData;
var
	S : String;
	SubParam : String;
	DiceText: String;
	Left_Rate,Right_Rate : Integer;
	SW_Mode, Left_Null, Right_Null: Boolean;
	SW_Adder : String;
	B : TTRPGBuff;
	procedure AddDice(const Dices,Vals:Integer);
	begin
		if SW_Mode then begin
			if Left_Null then begin
				Right_Rate := Right_Rate + Dices;
			end else begin
				Left_Rate := Left_Rate + Dices;
			end;

			SW_Adder := SW_Adder + PlusNum(0,Vals,DiceText);
		end else S := S + PlusNum(Dices,Vals,DiceText);
	end;
	procedure AddSubParam(const S:String);
	begin
		if S <> '' then SubParam := SubParam + '[' + S + ']';
	end;
	procedure GetDiceMode;
	var
		I : Integer;
		Start_Index,Index_Length : Integer;
		GetText_Mode,Text_Getted : Boolean;

	Label Halt;
	begin
		GetText_Mode := False;
		Text_Getted := False;
		Index_Length := 0;
		Start_Index := 0;
		for I := 1 to Length(S) do begin
			if (I = 1) and (S[1] in ['+','-']) then
				Continue
			else if S[I] in ['+','-','*','/','^','%'] then begin
				break;
			end else if IsDBCSLeadChar(S[I]) then begin
				break;
			end else if S[I] in ['0'..'9'] then begin
				if GetText_Mode then begin
					GetText_Mode := False;
					Text_Getted := True;
				end;
				Continue;
			end else if (not Text_Getted) then begin
				if not GetText_Mode then begin
					GetText_Mode := True;
					Start_Index := I;
				end;
				Inc(Index_Length);
			end else break;
		end;

		if (Start_Index > 0) then begin
			DiceText := Copy(S,Start_Index,Index_Length);

			if Start_Index <> 1 then begin
				if not tryStrToInt(Copy(S,1,Start_Index - 1),Left_Rate) then goto Halt;
				Left_Null := False;
			end else Left_Null := True;

			if Start_Index + Index_Length >= I then begin
				Right_Null := True;
			end else begin
				if not tryStrToInt(Copy(S,Start_Index + Index_Length,I - Start_Index - Index_Length),Right_Rate) then goto Halt;
				Right_Null := False;
			end;

			Delete(S,1,I - 1);
			SW_Mode := True;
		end else goto Halt;
		Exit;
		Halt:
			DiceText := 'd';
			SW_Mode := False;
			Left_Rate := 0;
			Right_Rate := 0;
			Left_Null := False;
	end;
begin
	if not Assigned(ListBox1) then Exit;
	if ListBox1.ItemIndex >= 0 then begin
		SubParam := FData[Index].Message[ListBox1.ItemIndex].Text;
		S := ExtractSpacesDem(SubParam);

		SW_Adder := '';
		//BaceBuffC

		SW_Mode := False;
		DiceText := '';
		GetDiceMode;

		Label9.Caption := DiceText;
		Label10.Caption := DiceText;
		Label11.Caption := DiceText;

		if (CheckBox1.Checked) and (FateDSE.Value > 0) then begin
			AddDice(FateDSE.Value,0);
			AddSubParam('tFCg' + inttostr(FateDSE.Value));
		end;

		if CheckBox3.Checked then begin
			AddDice(B1DSE.Value,B1BDSE.Value);
			AddSubParam(Edit1.Text);
		end;
		if CheckBox4.Checked then begin
			AddDice(B2DSE.Value,B2BDSE.Value);
			AddSubParam(Edit2.Text);
		end;

		if CheckBox5.Checked then begin
			AddDice(B3DSE.Value,B3BDSE.Value);
			AddSubParam(Edit3.Text);
		end;

		B := TTRPGBuff.Create;
		FData[Index].Buffs.FindBuff(FData[Index].Message[ListBox1.ItemIndex].Tags,B);
		if (B.EffectDices <> 0) or (B.EffectVal <> 0) then begin
			AddDice(B.EffectDices,B.EffectVal);
			AddSubParam(B.Name);
		end;
		B.Free;

		if SW_Mode then begin
			S := ifthen(Left_Null,'',inttostr(Left_Rate)) + DiceText +
			ifthen(Right_Null,'',inttostr(Right_Rate)) + SW_Adder + S;
		end;

		Memo1.Text := trim(S + ' ' + SubParam);
	end;
end;

procedure TMainForm.R1Click(Sender: TObject);
begin
	if Index >= 0 then begin
		ListView2.Items.Clear;
		FData[Index].Buffs.Clear;
		PrintData;
	end;
end;

procedure TMainForm.ReloadBuff(const LI: TListItem);
var
	I : Integer;
	D : TTRPGBuff;
begin
	if Index < 0 then Exit;

	I := LI.Index;
	D := FData[Index].Buffs[I];
	LI.Caption := D.Name;
	LI.SubItems.Clear;

	LI.SubItems.Add(D.Tags[0] + PlusNum(D.EffectDices,D.EffectVal));
	if D.Left <= 0 then Li.SubItems.Add('iv')
	else LI.SubItems.Add(inttostr(D.Left) + 'R');
	LI.Checked := D.Checked;
end;

procedure TMainForm.ReloadData(const LI: TListItem);
var I : Integer;
	function GetValue(const Tp : TTRPGParamCodes;const Val,Max:Integer):String;
	begin
		Case Tp of
			tpcNowMax : Result := IntToStr(Val) + '/' + IntToStr(Max);
			tpcNow :  Result := IntToStr(Val);
			tpcNone : Result := '';
		End;
	end;
begin
	I := LI.Index;
	LI.Caption := FData[I].Name;

	Li.SubItems.Clear;
	Li.SubItems.Add(GetValue(FData[I].HP_Type,FData[I].HP_Now,FData[I].HP_Max));
	Li.SubItems.Add(GetValue(FData[I].MP_Type,FData[I].MP_Now,FData[I].MP_Max));
end;

procedure TMainForm.S1Click(Sender: TObject);
begin
	DestEditForm.Execute;
	Caption := 'LimeChat _CX}NǗc[ : ' + DestEditForm.ActiveProsess;
end;

procedure TMainForm.SelectData(const ItemIndex: Integer);
var
	D : TDecodedTRPGCharactorData;
  LC: Integer;

	procedure PointsRoutine(const Vis:TTRPGParamCodes;
		Now,Max:TDialSpinEdit;L,SL:TLabel;NowVal,MaxVal:Integer);
	begin
		Now.Visible := Vis <> tpcNone;
		Max.Visible := Vis = tpcNowMax;
		L.Visible := Vis <> tpcNone;
		SL.Visible := Vis = tpcNowMax;

		Now.Value := NowVal;
		Max.Value := MaxVal;
	end;
begin                   
	ListView2.Items.BeginUpdate;
	ListView2.OnChange := NIL;
	D := FData[ItemIndex];     
	Index := ItemIndex;
	
	HPLA.Caption := D.HP_Name;
	MPLA.Caption := D.MP_Name;
	FPLA.Caption := D.FP_Name;
	FMPLA.Caption := D.FMP_Name;

	PointsRoutine(D.HP_Type,HPDSE,MHPDSE,HPLA,HPLB,D.HP_Now,D.HP_Max);
	PointsRoutine(D.MP_Type,MPDSE,MMPDSE,MPLA,MPLB,D.MP_Now,D.MP_Max);
	PointsRoutine(D.FP_Type,FPDSE,MFPDSE,FPLA,FPLB,D.FP_Now,D.FP_Max);
	PointsRoutine(D.FMP_Type,FMPDSE,MFMPDSE,FMPLA,FMPLB,D.FMP_Now,D.FMP_Max);

	ListBox1.Items.BeginUpdate;
	ListBox1.Items.Clear;
	for LC := 0 to D.Message.Count - 1 do begin
		ListBox1.Items.Add(D.Message[LC].Text);
	end;
	ListBox1.Items.EndUpdate;

	ListView2.Items.Clear;

	for LC := 0 to D.Buffs.Count - 1 do begin
		ReloadBuff(ListView2.Items.Add);
	end;
	ListView2.OnChange := ListView2Change;
	ListView2.Items.EndUpdate;
end;

procedure TMainForm.SetRoundNum;
begin
	ListView2.Columns[0].Caption := 'C(:' + IntToStr(FRoundCounter + 1) + '^[)';
end;

end.
