unit FVariable;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, ComCtrls, NCommon, StringUnitLight, CChara;

type
	TValForm = class(TForm)
		Label1: TLabel;
		Edit1: TEdit;
		Label2: TLabel;
		Edit2: TEdit;
		Label3: TLabel;
		Label4: TLabel;
		RichEdit1: TRichEdit;
		Label5: TLabel;
		Label6: TLabel;
		Button1: TButton;
		Button2: TButton;
    procedure FormDestroy(Sender: TObject);
	private
		FData: TTRPGVariable;
		procedure SetData(const Value: TTRPGVariable);
		function GetData: TTRPGVariable;
		{ Private 錾 }
	public
		{ Public 錾 }
		function Execute : Boolean;
	published
		property Data : TTRPGVariable read GetData write SetData;
	end;

var
  ValForm: TValForm;

implementation

{$R *.dfm}

{ TValForm }

function TValForm.Execute: Boolean;
begin
	if not Assigned(FData) then FData := TTRPGVariable.Create;
	ValForm.SetData(FData);
	Result := ShowModal = mrOK;

	FData.Name := Edit1.Text;
	FData.Value := Edit2.Text;
	FData.Tags.Text := RichEdit1.Lines.Text;
end;

procedure TValForm.FormDestroy(Sender: TObject);
begin
	FData.Free;
end;

function TValForm.GetData: TTRPGVariable;
begin
	if not Assigned(FData) then FData := TTRPGVariable.Create;
	Result := FData;
end;

procedure TValForm.SetData(const Value: TTRPGVariable);
begin
	if Value = NIL then begin
		FData.Name := '';
		FData.Value := '';
		FData.Tags.Text := '';
	end else begin
		FData.Assign(Value);
	end;
	Edit1.Text := FData.Name;
	Edit2.Text := FData.Value;
	RichEdit1.Text := FData.Tags.Text;
end;

end.
