unit NCommon;

interface
uses
	StringUnitLight, Types;
{{}
function TrimLeftJP(const S:String):String;
function TrimRightJP(const S:String):String;  
function GetLeftTrimer(const S: string): string;
function GetRightTrimer(const S: string): string;
function TrimJP(const S:String):String;
function EndsStr(const SubS,S:String):Boolean;  
function EndsText(const SubS,S:String):Boolean;
function StartsStr(const SubS,S:String):Boolean;
function StartsText(const SubS,S:String):Boolean;
function InText(const SubS,S:String):Boolean;   
function ReplaceStr(const S,Before,After:String):String; 
function ReplaceText(const S,Before,After:String):String;

{L֐ExtractWordDemiliter̗łB}
function ExtractWordDem(var S:String;const Dem:String = ','):String;
function ExtractWordParts(const Word: string; const Index: Integer;
		const Delimiter: String; const IgnoreCase : Boolean = False): string;

function FindSpacesDem(var S:String;var SpacesByte : Integer):String;
function ExtractSpacesDem(Var S : String):String;

function FindAndDeleteStr(const SubS:String;var S:String):Boolean;
function AddText(const Text,Adder:String):String;

function RectFromSize(const X,Y,W,H: Integer) : TRect;overload;
function RectFromSize(const Pt:TPoint;const W,H: Integer) : TRect;overload;

implementation

function TrimJP(const S: string): string;
var
  I, L: Integer;
begin
	L := Length(S);
	I := 1;
	while (I <= L) do begin
		if (S[I] <= ' ') then Inc(I)
		else if (Copy(S,I,2) = '@') then Inc(I,2)
		else break;
	end;

	if I > L then Result := '' else begin
		while True do begin
			if S[L] <= ' ' then Dec(L)
			else if (Copy(S,L - 1,2) = '@') then Dec(L,2)
			else break;
		end;
		Result := Copy(S, I, L - I + 1);
	end;
end;

function TrimLeftJP(const S: string): string;
var
	I, L: Integer;
begin
	L := Length(S);
	I := 1;
	while True do begin
		if (I <= L) and (S[I] <= ' ') then
			Inc(I)
		else if (I <= L) and (Copy(S,I,2) = '@') then
			Inc(I,2)
		else break;
	end;
	Result := Copy(S,I,L - I + 1);
end;

function TrimRightJP(const S: string): string;
var
  I, L: Integer;
begin
	L := Length(S);
	I := 1;

	if I > L then Result := '' else begin
		while True do begin
			if S[L] <= ' ' then Dec(L)
			else if (Copy(S,L - 1,2) = '@') then Dec(L,2)
			else break;
		end;
		Result := Copy(S, I, L - I + 1);
	end;
end;

function GetLeftTrimer(const S: string): string;
var
	I, L: Integer;
begin
	L := Length(S);
	I := 1;
	while I <= L do begin
		if (I <= L) and (S[I] <= ' ') then
			Inc(I)
		else if (I <= L) and (Copy(S,I,2) = '@') then
			Inc(I,2)
		else break;
	end;
	Result := Copy(S,1,I - 1);
end;

function GetRightTrimer(const S: string): string;
var
  I, L: Integer;
begin
	L := Length(S);
	I := L;

	if I > L then Result := '' else begin
		while L > 0 do begin
			if S[L] <= ' ' then Dec(L)
			else if (Copy(S,L - 1,2) = '@') then Dec(L,2)
			else break;
		end;
		Result := Copy(S, L, I - L + 1);
	end;
end;


function EndsStr(const SubS,S:String):Boolean;
begin
	Result := AnsiStringPartsCompare(SubS,S,Length(S) - Length(SubS) + 1);
end;
function EndsText(const SubS,S:String):Boolean;
begin
	Result := AnsiTextPartsCompare(SubS,S,Length(S) - Length(SubS) + 1);
end;
function StartsStr(const SubS,S:String):Boolean;
begin
	Result := AnsiStringPartsCompare(SubS,S,1);
end;
function StartsText(const SubS,S:String):Boolean;
begin
	Result := AnsiTextPartsCompare(SubS,S,1);
end;
function InText(const SubS,S:String):Boolean;
begin
	Result := (1 <= (RangeAnsiPosForward(SubS, S,1,MaxInt,True)));
end;

function ReplaceStr(const S,Before,After:String):String;
var
	Point,BL,AL: Integer;
begin
	Result := S;
	BL := Length(Before);
	AL := Length(After);
	Point := RangeAnsiPosForward(Before,S,1);
	while Point > 0 do begin
		Delete(Result,Point,BL);
		Insert(After,Result,Point);
		Point := RangeAnsiPosForward(Before,Result,Point + AL);
	end;
end;     

function ReplaceText(const S,Before,After:String):String;
var
	Point,BL,AL: Integer;
begin
	Result := S;
	BL := Length(Before);
	AL := Length(After);
	Point := RangeAnsiPosForward(Before,S,1,MaxInt,True);
	while Point > 0 do begin
		Delete(Result,Point,BL);
		Insert(After,Result,Point);
		Point := RangeAnsiPosForward(Before,Result,Point + AL,MaxInt,True);
	end;
end;

function ExtractWordDem(var S:String;const Dem:String = ','):String;
var
	i:Integer;
begin
	i := AnsiPosForward(Dem,S);
	if i = 0 then begin
		Result := S;
		S := '';
	end else begin
		Result := Copy(S,1,i - 1);
		Delete(S,1,i + Length(Dem) - 1);
	end;
end;

function ExtractWordParts(const Word: string; const Index: Integer;
		const Delimiter: String;const IgnoreCase : Boolean = False): string;
var
	StrIndex, FoundIndex, LC : Integer;
begin
	StrIndex := 1;
	for LC := 0 to Index do begin
		FoundIndex := RangeAnsiPosForward(Delimiter,Word,StrIndex,MaxInt,IgnoreCase);
		If (FoundIndex > 0) then begin
			if (LC = Index) then begin
				Result := Copy(Word,StrIndex,FoundIndex - StrIndex + 1);
				Exit;
			end else StrIndex := FoundIndex;
		end else break;
	end;
	Result := Word; // UnFound
end;

procedure TestFindSpacesDem;
var
	S,SubS : String;
	I : Integer;
begin
	S := 'Test @ 	24';
	SubS := FindSpacesDem(S,I);
	Assert(I = 5,'');
	Assert(S = '24','');
	Assert(SubS = 'Test','');

	S := '"Test @" 	24';
	SubS := FindSpacesDem(S,I);

	Assert(I = 2,'');
	Assert(S = '24','');
	Assert(SubS = 'Test @','');

	S := 'i(Test @j) 24';
	SubS := FindSpacesDem(S,I);
	
	Assert(SubS = 'Test','');
end;

function FindSpacesDem(var S:String;var SpacesByte : Integer):String;
var
	I, L: Integer;
	DestPt,KakkoCnT : Integer;
	function GetSpacesByte(const StartIndex:Integer):Integer;
	var
		I, L: Integer;
	begin
		L := Length(S);
		I := 0;
		while True do begin
			if (StartIndex + I <= L) and (S[StartIndex + I] <= ' ') then
				inc(I,1)
			else if (I <= L) and (Copy(S,StartIndex + I,2) = '@') then
				Inc(I,2)
			else break;
		end;
		Result := I;
    Delete(S,StartIndex,Result);
	end;

	function CheckSpaceDelimiter(var Str : String):Boolean;
	begin
		if I = L then begin
			Str := Copy(S,2,I - 1);
			S := '';
			Result := True;
		end else if (S[I + 1] <= ' ') or (Copy(S,I,2) = '@') then begin
			Str := Copy(S,2,I - 2);
			SpacesByte := GetSpacesByte(I + 1);
			Delete(S,1,I); 
			Result := True;
		end else Result := False;
	end;
begin
	L := Length(S);
	I := 1;
	SpacesByte := 0;
	if S = '' then begin
		Result := '';
		Exit;
  end;
	if (S[1] = '"') or (S[1] = '') then DestPt := 1
	else if S[1] = '(' then DestPt := 2
	Else if Copy(S,1,2) = 'i' then begin
		DestPt := 2;
		Delete(S,1,2);
		Insert('(',S,1);
	end else DestPT := 0;

	Case DestPt of
		0 : begin
			while I <= L do begin
				if S[I] <= ' ' then begin
					Result := Copy(S,1,I - 1); 
					SpacesByte := GetSpacesByte(I);
					Delete(S,1,I - 1);
					Exit;
				end else if Copy(S,I,2) = '@' then begin
					Result := Copy(S,1,I - 1);
					SpacesByte := GetSpacesByte(I);
					Delete(S,1,I - 1);
					Exit;
				end else Inc(I);
			end;
		end;
		1 : begin
			while I <= L do begin
				if (S[I] = '"') then begin
					if CheckSpaceDelimiter(Result) then Exit else inc(i);
        end else inc(i);
			end;
		end;
		2: begin
			KakkoCnT := 0;
			while I <= L do begin
				if (S[I] = '(') then begin
					Inc(KakkoCNT);
					inc(i);
				end else if (Copy(S,i,2) = 'i') then begin
					Inc(KakkoCNT);
					inc(i,2);
				end else if (S[I] = ')') then begin
					Dec(KakkoCNT);
					if KakkoCNT <= 0 then
						if CheckSpaceDelimiter(Result) then Exit;
					inc(i);
				end else if (Copy(S,i,2) = 'j') then begin
					Dec(KakkoCNT);

					if KakkoCNT <= 0 then
						if CheckSpaceDelimiter(Result) then Exit;  
					inc(i,2);
				end else inc(i);
			end;
		end;
	end;
	Result := S;
	S := '';
end;

function ExtractSpacesDem(var S:String):String;
var I : Integer;
begin
	Result := FindSpacesDem(S,I);
end;

function FindAndDeleteStr(const SubS:String;var S:String):Boolean;
var
	StrIndex : Integer;
begin
	StrIndex := AnsiPosForward(SubS,S,True);
	Result := StrIndex > 0;
	if Result then begin
		Delete(S,StrIndex,Length(SubS));
	end;
end;

function AddText(const Text,Adder:String):String;
begin
	if TrimJP(Adder) = '' then Exit;
	if (Text <> '') and (not EndsStr(#13#10,Text)) then
		Result := Text + #13#10 else Result := Text;
	Result := Result + Adder;
end;

function RectFromSize(const X,Y,W,H: Integer) : TRect;
begin
	Result := Rect(X,Y,X + W,Y + H);
end;

function RectFromSize(const Pt:TPoint;const W,H: Integer) : TRect;
begin
	Result := Rect(Pt.X,Pt.Y,Pt.X + W, Pt.Y + H);
end;

end.
